<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: dmx_framework.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('dmx__framework_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">dmx_framework.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="dmx__framework_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;sacn/cpp/receiver.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;array&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">using</span> Handle = sacn::Receiver::Handle;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="structDMXPackage.html">   33</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structDMXPackage.html">DMXPackage</a></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structDMXPackage.html#a38546526ad51ed8af7e3163510cdd2b0">   35</a></span>&#160;    std::array&lt;uint8_t, 512&gt; <a class="code" href="structDMXPackage.html#a38546526ad51ed8af7e3163510cdd2b0">channels</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="structDMXPackage.html#a758e626a8247c8b2fc584f9914638a87">   36</a></span>&#160;    std::array&lt;bool, 512&gt; <a class="code" href="structDMXPackage.html#a758e626a8247c8b2fc584f9914638a87">is_new</a>;</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="structDMXPackage.html#a4dd7d6d06654fa9769543412f1ca28fc">   37</a></span>&#160;    std::size_t <a class="code" href="structDMXPackage.html#a4dd7d6d06654fa9769543412f1ca28fc">length</a>{};</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;};</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classDMXManager.html">   43</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDMXManager.html">DMXManager</a> : <span class="keyword">public</span> sacn::Receiver::NotifyHandler</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;{</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="keyword">private</span>:</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    uint16_t footprint_size;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    uint16_t start_address;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    sacn::Receiver recv{};</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    sacn::Receiver::Settings config{};</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    std::function&lt;void(<a class="code" href="structDMXPackage.html">DMXPackage</a>)&gt; callback{};</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    std::array&lt;uint8_t, 512&gt; previous_dmx_values;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">void</span> HandleUniverseData(Handle receiver_handle, <span class="keyword">const</span> etcpal::SockAddr &amp;source_addr,</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                            <span class="keyword">const</span> SacnRemoteSource &amp;source_info, <span class="keyword">const</span> SacnRecvUniverseData &amp;universe_data) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span> HandleSourcesLost(Handle handle, uint16_t universe, <span class="keyword">const</span> std::vector&lt;SacnLostSource&gt; &amp;lost_sources) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <a class="code" href="classDMXManager.html#a8de924e678a6fe1b13ecac913fc443a4">DMXManager</a>(uint16_t universe_id, uint16_t start_address, uint16_t footprint_size);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="classDMXManager.html#a8c6a3042a47d5f44de39c448b53eca90">~DMXManager</a>();</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDMXManager.html#a30a723aa407e8faa2e446667789ba6e6">start</a>();</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDMXManager.html#ab45fc64c9b609a36319c1a2831ef1b24">stop</a>();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classDMXManager.html#ae148618723b2c9d8414206db154118fc">set_dmx_callback</a>(std::function&lt;<span class="keywordtype">void</span>(<a class="code" href="structDMXPackage.html">DMXPackage</a>)&gt; f);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;};</div>
<div class="ttc" id="aclassDMXManager_html"><div class="ttname"><a href="classDMXManager.html">DMXManager</a></div><div class="ttdoc">The DMXManager class receives sacn-frames, processes them and offers a simple API to retreive the dat...</div><div class="ttdef"><b>Definition:</b> dmx_framework.hpp:44</div></div>
<div class="ttc" id="aclassDMXManager_html_a30a723aa407e8faa2e446667789ba6e6"><div class="ttname"><a href="classDMXManager.html#a30a723aa407e8faa2e446667789ba6e6">DMXManager::start</a></div><div class="ttdeci">void start()</div><div class="ttdoc">starts the receiver</div><div class="ttdef"><b>Definition:</b> dmx_framework.cpp:57</div></div>
<div class="ttc" id="aclassDMXManager_html_a8c6a3042a47d5f44de39c448b53eca90"><div class="ttname"><a href="classDMXManager.html#a8c6a3042a47d5f44de39c448b53eca90">DMXManager::~DMXManager</a></div><div class="ttdeci">~DMXManager()</div><div class="ttdoc">Destructor.</div><div class="ttdef"><b>Definition:</b> dmx_framework.cpp:48</div></div>
<div class="ttc" id="aclassDMXManager_html_a8de924e678a6fe1b13ecac913fc443a4"><div class="ttname"><a href="classDMXManager.html#a8de924e678a6fe1b13ecac913fc443a4">DMXManager::DMXManager</a></div><div class="ttdeci">DMXManager(uint16_t universe_id, uint16_t start_address, uint16_t footprint_size)</div><div class="ttdoc">The DMX Manager class receives incoming sacn-packets and provides an abstraction-layer for the applic...</div><div class="ttdef"><b>Definition:</b> dmx_framework.cpp:23</div></div>
<div class="ttc" id="aclassDMXManager_html_ab45fc64c9b609a36319c1a2831ef1b24"><div class="ttname"><a href="classDMXManager.html#ab45fc64c9b609a36319c1a2831ef1b24">DMXManager::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Stops the receiver.</div><div class="ttdef"><b>Definition:</b> dmx_framework.cpp:65</div></div>
<div class="ttc" id="aclassDMXManager_html_ae148618723b2c9d8414206db154118fc"><div class="ttname"><a href="classDMXManager.html#ae148618723b2c9d8414206db154118fc">DMXManager::set_dmx_callback</a></div><div class="ttdeci">void set_dmx_callback(std::function&lt; void(DMXPackage)&gt; f)</div><div class="ttdoc">Sets the callback-function for incoming sacn-packets.</div><div class="ttdef"><b>Definition:</b> dmx_framework.cpp:134</div></div>
<div class="ttc" id="astructDMXPackage_html"><div class="ttname"><a href="structDMXPackage.html">DMXPackage</a></div><div class="ttdoc">A struct to hold processed dmx-information.</div><div class="ttdef"><b>Definition:</b> dmx_framework.hpp:34</div></div>
<div class="ttc" id="astructDMXPackage_html_a38546526ad51ed8af7e3163510cdd2b0"><div class="ttname"><a href="structDMXPackage.html#a38546526ad51ed8af7e3163510cdd2b0">DMXPackage::channels</a></div><div class="ttdeci">std::array&lt; uint8_t, 512 &gt; channels</div><div class="ttdef"><b>Definition:</b> dmx_framework.hpp:35</div></div>
<div class="ttc" id="astructDMXPackage_html_a4dd7d6d06654fa9769543412f1ca28fc"><div class="ttname"><a href="structDMXPackage.html#a4dd7d6d06654fa9769543412f1ca28fc">DMXPackage::length</a></div><div class="ttdeci">std::size_t length</div><div class="ttdef"><b>Definition:</b> dmx_framework.hpp:37</div></div>
<div class="ttc" id="astructDMXPackage_html_a758e626a8247c8b2fc584f9914638a87"><div class="ttname"><a href="structDMXPackage.html#a758e626a8247c8b2fc584f9914638a87">DMXPackage::is_new</a></div><div class="ttdeci">std::array&lt; bool, 512 &gt; is_new</div><div class="ttdef"><b>Definition:</b> dmx_framework.hpp:36</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_a7bb9b575703809b9fbb7ad7f723668f.html">local_app</a></li><li class="navelem"><a class="el" href="dir_fda4a0efc48fcf730384a6acb81f3b5f.html">dmx_framework</a></li><li class="navelem"><a class="el" href="dir_08cf37bc7b05d6b7e7d7699963bcf6ea.html">include</a></li><li class="navelem"><a class="el" href="dmx__framework_8hpp.html">dmx_framework.hpp</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
